Include MASM32RT.INC
Include ExtCpuLoad.inc

Main		PROTO
InitNTdll   PROTO
GetCpuLoad  PROTO
HandleError PROTO :DWORD

.CODE

Start:

    Invoke Main
    Invoke ExitProcess,0

Main Proc

Local sInfo:SYSTEM_INFO
Local szBuf[128]:BYTE

	print SADD("Extended CpuLoad-Info",13,10)
	print SADD("Shows CpuLoad, Idletime, Kerneltime and Usertime of the processor in percent",13,10,13,10)
;    Get_Input szBegin,inbuf

    invoke GetSystemInfo,ADDR sInfo
    print chr$("Number of CPUs: ")
    print ustr$(sInfo.dwNumberOfProcessors)
    print ADDR CRLF2
    mov ecx,sInfo.dwNumberOfProcessors
    sub ecx,1
    jz @F
	    print SADD("Sorry, only for single CPU systems...")
	    jmp _exit
	    
@@:	invoke InitNTdll
    test eax,eax
    jz _exit
;-- initialize time values
	invoke GetCpuLoad

;-- start processor usage display
@@:	invoke Sleep,250
	invoke GetCpuLoad
	invoke wsprintf,ADDR szBuf,SADD("CpuLoad: %3u%% (Idle: %3u%% - Kernel: %3u%% - User: %3u%%)",13,10),dwLoad,dwIdle,dwKernel,dwUser
	print addr szBuf
	call crt__kbhit
    test eax, eax
    jz @B
	
_exit:
    print ADDR CRLF
    Get_Input szExit,inbuf
	
    ret
Main EndP

GetCpuLoad PROC
;Local dwRetLen:DWORD
Local temp:REAL4

;-- copy old time values to sppiOld
	invoke MemCopy,ADDR sppiAct,ADDR sppiOld,SIZEOF(_SPPI)
;-- copy old SystemTime to qwSysTimeOld
	lea edx,qwSysTimeAct
	mov eax,[edx]
	mov ecx,[edx+4]
	mov DWORD PTR [qwSysTimeOld],eax
	mov DWORD PTR [qwSysTimeOld+4],ecx

;-- retrieve new time values by ZwQuerySystemInformation
;	lea eax,dwRetLen			; [out,optional] ReturnLength
	push 0 ;eax
	push SIZEOF(_SPPI)			; [in] SystemInformationLength in bytes
	lea eax,sppiAct				; [in,out] pointer to SystemInformation structure
	push eax
	push SysPPInf				; [in] SYSTEM_INFORMATION_CLASS
	call lpZwQSI
;-- retrieve system time by ZwQuerySystemTime	
	lea edx,qwSysTimeAct		; [out] Pointer to a LARGE_INTEGER that receives the system time.
	push edx
	call lpZwQST
	
	finit
;-- Compute time spent since last call
	fild QWORD PTR qwSysTimeAct ; st = new system time 
	fild QWORD PTR qwSysTimeOld ; st = old system time, st(1) = new system time
	fsubp st(1),st				; st = nanoseconds elapsed
	fstp REAL4 PTR temp
	
;-- Compute CPU-Load and Idle in %
	mov eax,100
	push eax	
	fild QWORD PTR sppiAct.IdleTime
	fild QWORD PTR sppiOld.IdleTime
	fsubp st(1),st				; st = nanoseconds idle time
	fimul DWORD PTR [esp]
	fdiv REAL4 ptr temp			; st = percent idle time
	fistp DWORD PTR [esp]
	pop edx                     ; edx = percent idle time
	mov dwIdle,edx
	sub eax,edx                 ; eax = processor usage time
	mov dwLoad,eax
	
;-- Compute KernelTime in %
	push 100
	fild QWORD PTR sppiAct.KernelTime
	fild QWORD PTR sppiOld.KernelTime
	fsubp st(1),st				; st = nanoseconds kernel time
	fimul DWORD PTR [esp]
	fdiv REAL4 ptr temp			; st = percent kernel time
	fistp DWORD PTR [esp]
	pop dwKernel
	
;-- Compute UserTime in %
	push 100
	fild QWORD PTR sppiAct.UserTime
	fild QWORD PTR sppiOld.UserTime
	fsubp st(1),st				; st = nanoseconds user time
	fimul DWORD PTR [esp]
	fdiv REAL4 ptr temp			; st = percent user time
	fistp DWORD PTR [esp]
	pop dwUser

	ret
	
GetCpuLoad EndP


InitNTdll PROC
Local hLib:HANDLE

	invoke LoadLibrary,SADD("ntdll.dll")
    mov hLib,eax
    test eax,eax
    jz _exitError
    
	invoke GetProcAddress,hLib,SADD("ZwQuerySystemInformation")
    mov lpZwQSI,eax
    test eax,eax
    jz _exitError1
    
	invoke GetProcAddress,hLib,SADD("ZwQuerySystemTime")
    mov lpZwQST,eax
    test eax,eax
    jz _exitError1
	
	invoke FreeLibrary,hLib
	ret
	    
_exitError1:
	invoke HandleError,SADD(13,10,"GetProcAddress failed. Error: ")
	invoke FreeLibrary,hLib
	xor eax,eax
	ret
_exitError:
	invoke HandleError,SADD(13,10,"GetModuleHandle failed. Error: ")
	xor eax,eax
	ret
	
InitNTdll EndP

HandleError proc lpTitle:DWORD
	
	LOCAL lpMsgBuffer 	: LPVOID
	
	; calculate language ID, asm version of MAKELANGID
	mov cx, SUBLANG_DEFAULT
	shl ecx, 10
	;or  cx, LANG_NEUTRAL		; LANG_NEUTRAL = 0, nothing necessary
	
	push NULL					; we don't need this
	push 0						; min. size of output buffer if we use FORMAT_MESSAGE_ALLOCATE_BUFFER
	lea eax,lpMsgBuffer
	push eax					; address of buffer
	push ecx					; language ID, calculated above
	invoke GetLastError			; get error number
	push eax					; push return value = error ID
	push NULL					; can be used to format a string, we don't need it
	mov edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
	push edx
	call FormatMessage
	
	; Display error-message
	print lpTitle
	print lpMsgBuffer
;	invoke MessageBox, NULL, lpMsgBuffer, lpTitle, MB_OK or MB_ICONSTOP
	
	; free memory
	invoke LocalFree, lpMsgBuffer

	ret

HandleError endp

End Start
